// This file is part of udpc.
//
// Copyright 2013 by Milan Straka <fox@ucw.cz>.
// Copyright 2013 by David Marecek <marecek@ufal.mff.cuni.cz>.
//
// Udpc is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Udpc is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with udpc.  If not, see <http://www.gnu.org/licenses/>.

#pragma once

#include <vector>

#include "common.h"

// Computes directed minimum spanning tree, a.k.a. minimum arborescence.
// Input:
//   w of size N+1 x N+1.
//   w[0] is root and w[0][j] is ignored.
//   w[i>0] is nonroot, w[i][j] is weight of edge v_j -> v_i.
// Output:
//   parent of size N+1.
//   parent[0] is -1
//   parent[i] is parent of v_i

template<class T>
void directed_mst(const vector<vector<T>>& w, vector<int>& parent);
