// This file is part of udpc.
//
// Copyright 2013 by Milan Straka <fox@ucw.cz>.
// Copyright 2013 by David Marecek <marecek@ufal.mff.cuni.cz>.
//
// Udpc is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Udpc is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with udpc.  If not, see <http://www.gnu.org/licenses/>.

#pragma once

#include "model.h"

class baseline_model : public incremental_model, public block_model {
 public:
  baseline_model(const model_options& options);

  virtual void construct(const corpus& c);
  virtual void initialize(const corpus& c, double* logprob = NULL);

  virtual void change_parent(const sentence& s, const node& n, int new_parent, double* prob = NULL);

  virtual bool use_edge_prob() { return true; }
  virtual double edge_prob(const sentence& s, int parent, int node);
 private:
  inline void count_edge(int delta, const node& n, const node* p, double& prob);

  enum { UNDEFINED, RANDOM, LEFT, RIGHT } mode;
};
