// This file is part of udpc.
//
// Copyright 2013 by Milan Straka <fox@ucw.cz>.
// Copyright 2013 by David Marecek <marecek@ufal.mff.cuni.cz>.
//
// Udpc is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Udpc is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with udpc.  If not, see <http://www.gnu.org/licenses/>.

#include "common.h"
#include "model.h"
#include "utils/utils.h"

model_options parse_model_options(const str& options) {
  vector<str> parts;
  split(options, ',', parts);

  unordered_map<str, str> result;
  foreach (auto& part, parts)
    if (!part.empty()) {
      size_t eq_pos = part.find('=');
      if (eq_pos == str::npos)
        result[""] = part;
      else
        result[part.substr(0, eq_pos)] = part.substr(eq_pos + 1);
    }

  return result;
}
